VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmLatexEdit 
   Caption         =   "Latex-Eingabe"
   ClientHeight    =   3150
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4950
   OleObjectBlob   =   "frmLatexEdit.frx":0000
   StartUpPosition =   1  'Fenstermitte
End
Attribute VB_Name = "frmLatexEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function OpenProcess Lib "kernel32" _
(ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, _
ByVal dwProcessId As Long) As Long

Private Declare Function GetExitCodeProcess Lib "kernel32" _
(ByVal hProcess As Long, lpExitCode As Long) As Long

Private Const STATUS_PENDING = &H103&
Private Const PROCESS_QUERY_INFORMATION = &H400



Public Function ShellandWait(ExeFullPath As String, _
Optional TimeOutValue As Long = 0) As Boolean
    
    Dim lInst As Long
    Dim lStart As Long
    Dim lTimeToQuit As Long
    Dim sExeName As String
    Dim lProcessId As Long
    Dim lExitCode As Long
    Dim bPastMidnight As Boolean
    
    On Error GoTo ErrorHandler

    lStart = CLng(Timer)
    sExeName = ExeFullPath

    'Deal with timeout being reset at Midnight
    If TimeOutValue > 0 Then
        If lStart + TimeOutValue < 86400 Then
            lTimeToQuit = lStart + TimeOutValue
        Else
            lTimeToQuit = (lStart - 86400) + TimeOutValue
            bPastMidnight = True
        End If
    End If

    lInst = Shell(sExeName, vbMinimizedNoFocus)
    
    lProcessId = OpenProcess(PROCESS_QUERY_INFORMATION, False, lInst)

    Do
        Call GetExitCodeProcess(lProcessId, lExitCode)
        DoEvents
        If TimeOutValue And Timer > lTimeToQuit Then
            If bPastMidnight Then
                 If Timer < lStart Then Exit Do
            Else
                 Exit Do
            End If
    End If
    Loop While lExitCode = STATUS_PENDING
    
    ShellandWait = True
   
ErrorHandler:
ShellandWait = False
Exit Function
End Function



Private Sub Cancel_Button_Click()
    Unload Me
End Sub

Private Sub Ok_Button_Click()
    Dim sOld As Shape
    Dim s As String
    Dim path As String
    Dim curpath As String
    Dim d11 As Double, d12 As Double, d21 As Double, d22 As Double
    Dim tx As Double, ty As Double
    Set sOld = ActiveShape
    If Not (sOld Is Nothing) Then
        sOld.GetMatrix d11, d12, d21, d22, tx, ty
    End If
    path = Environ$("TEMP")
    curpath = CurDir
    s = TextBox1.Text
    path = path & "\"
    Open (path + "teximport.tex") For Output As #1
    Print #1, "\documentclass[12pt,a4paper,ngerman]{report}"
    Print #1, "\usepackage{amsmath} "
    Print #1, "\usepackage[latin1]{inputenc} "
    Print #1, "\usepackage[T1]{fontenc} "
    Print #1, "\usepackage{ngerman} "
    Print #1, "\usepackage{bbm} "
    Print #1, "\usepackage{ae,aecompl} "
    Print #1, "\newcommand{\boldm}[1]{\mbox{\boldmath{$\mathrm {#1}$}}}"
    Print #1, "\def \b#1{\relax \ifmmode{\boldm {#1}\/}\else{$\bf {#1}\/$}\fi}"
    Print #1, "\begin{document} "
    Print #1, "\thispagestyle{empty}"
    Print #1, s
    Print #1, "\end{document}"
    Close #1
    ChDrive path
    ChDir path
    ShellandWait ("latex.exe """ + "teximport.tex""")
    ShellandWait ("dvips.exe """ + "teximport.dvi""")
    ChDrive curpath
    ChDir curpath
    Dim impflt As ImportFilter
    Dim impopt As StructImportOptions
    Set impopt = New StructImportOptions
    impopt.MaintainLayers = True
    Set impflt = ActiveLayer.ImportEx(path + "teximport.ps", cdrPSInterpreted, impopt)
    impflt.Finish
    Dim s1 As Shape
    Set s1 = ActiveShape
    Rem s1.SetPosition sOld.PositionX, sOld.PositionY
    If Not (sOld Is Nothing) Then
        s1.SetMatrix d11, d12, d21, d22, tx, ty
        sOld.Delete
    End If
    s1.Name = s
    s1.ObjectData("Comments") = s
    Unload Me
End Sub

